<template>
  <q-btn id="btn-avatar" unelevated no-caps>
    <!-- <q-avatar>
      <img :src="USER_PHOTO ? USER_PHOTO : '~assets/default.png'" />
    </q-avatar> -->
    <custom-avatar
      :photoUrl="userStore.userDetails.profile_picture_url"
      :name="
        userStore.userDetails.user_type === 'employer'
          ? userStore.userDetails.company_name
          : userStore.userDetails.first_name
      "
      :userType="userStore.userDetails.user_type"
      fontSize="17px"
    />
    <q-menu
      class="rounded-borders-10"
      style="padding: 30px 40px !important; width: 335px"
    >
      <div class="row">
        <div class="col flex justify-center">
          <!-- <q-avatar size="100px">
            <img :src="USER_PHOTO ? USER_PHOTO : '~assets/default.png'" />
          </q-avatar> -->
          <custom-avatar
            :photoUrl="userStore.userDetails.profile_picture_url"
            :name="
              userStore.userDetails.user_type === 'employer'
                ? userStore.userDetails.company_name
                : userStore.userDetails.first_name
            "
            :userType="userStore.userDetails.user_type"
            size="100px"
            fontSize="35px"
            shadow="shadow-6"
          />
        </div>
      </div>

      <div class="row q-mt-lg">
        <div class="col text-center">
          <p class="title-9">
            {{
              userStore.userDetails.first_name +
              " " +
              userStore.userDetails.last_name
            }}
          </p>
          <p
            v-show="userStore.userDetails.user_type === 'employer'"
            class="title-8"
          >
            {{ userStore.userDetails.company_name }}
          </p>
        </div>
      </div>

      <div class="row q-mt-lg" align="center">
        <div class="col">
          <q-btn
            id="view-profile"
            label="VIEW PROFILE"
            unelevated
            @click="onClickViewProfile(userStore.userDetails.user_type)"
            class="btn-md text-black rounded-borders"
          />
        </div>
      </div>

      <div
        v-if="userStore.userDetails.user_type === 'job-seeker'"
        class="row q-mt-md"
      >
        <div class="col">
          <q-btn
            id="saved-jobs"
            label="SAVED JOBS"
            unelevated
            @click="onClickSavedJobs"
            class="btn-md text-black rounded-borders"
          />
        </div>
      </div>

      <div class="row q-mt-md">
        <div class="col">
          <q-btn
            id="settings"
            label="SETTINGS"
            text
            unelevated
            @click="onClickSettings(userStore.userDetails.user_type)"
            class="btn-lg text-black rounded-borders"
          />
        </div>
      </div>

      <div class="row q-mt-md">
        <div class="col">
          <q-btn
            id="signout"
            label="SIGN OUT"
            text
            unelevated
            v-close-popup
            @click="doLogout"
            class="btn-md text-black rounded-borders"
          />
        </div>
      </div>
    </q-menu>
  </q-btn>
</template>

<script>
import { LocalStorage } from "quasar";
import { defineComponent, ref, computed } from "vue";
import { AUTH_ROUTE_NAMES } from "src/modules/auth/constants";
import { SETTINGS_JOBSEEKER_ROUTE_NAMES } from "src/modules/settings-jobseeker/constants";
import { SETTINGS_EMPLOYER_ROUTE_NAMES } from "src/modules/settings-employer/constants";
import { SAVED_JOBS_ROUTE_NAMES } from "src/modules/saved-jobs/constants";
import { COMPANY_PROFILE_ROUTE_NAMES } from "src/modules/company-profile/constants";
import { MY_PROFILE_ROUTE_NAMES } from "src/modules/my-profile/constants";
import usePageRouter from "src/hooks/pageRouter";
import CustomAvatar from "src/components/CustomAvatar.vue";
import { useUser } from "src/layouts/portals/store/user";
import { onMounted, onUnmounted } from "vue";

export default defineComponent({
  components: { CustomAvatar },
  name: "UserAccountMenu",

  setup() {
    const userStore = useUser();
    const { getBasicInfo, getEmployerInfo } = userStore;

    const { router } = usePageRouter();
    // const USER_PHOTO = ref(null);
    // const USER_NAME = ref(null);
    // const USER_PROFESSION = ref(null);
    // const USER_COMPANY = ref(null);
    // const USER_ROLE = ref(null);

    onMounted(() => {
      if (LocalStorage.getItem("auth").user_type === "employer") {
        getEmployerInfo(LocalStorage.getItem("auth").id);
      } else {
        getBasicInfo(LocalStorage.getItem("auth").id);
      }
    });

    onUnmounted(() => {
      userStore.$dispose();
    });

    const doLogout = () => {
      LocalStorage.clear();
      router.push({ name: AUTH_ROUTE_NAMES.Login.name });
    };

    // const fetchUser = () => {
    // USER_PHOTO.value = LocalStorage.getItem("auth").profile_picture_url;
    // USER_COMPANY.value = LocalStorage.getItem("auth").company_name;
    // USER_ROLE.value = LocalStorage.getItem("auth").user_type;
    // USER_NAME.value =
    //   LocalStorage.getItem("auth").first_name +
    //   " " +
    //   LocalStorage.getItem("auth").last_name;
    // };

    const onClickViewProfile = (role) => {
      return role === "employer"
        ? router.push({ name: COMPANY_PROFILE_ROUTE_NAMES.CompanyProfile.name })
        : router.push({ name: MY_PROFILE_ROUTE_NAMES.MyProfile.name });
    };

    const onClickSavedJobs = () => {
      router.push({ name: SAVED_JOBS_ROUTE_NAMES.SavedJobs.name });
    };

    const onClickSettings = (role) => {
      return role === "employer"
        ? router.push({ name: SETTINGS_EMPLOYER_ROUTE_NAMES.Settings.name })
        : router.push({ name: SETTINGS_JOBSEEKER_ROUTE_NAMES.Settings.name });
    };

    // fetchUser();

    return {
      // USER_PHOTO,
      // USER_NAME,
      // USER_PROFESSION,
      // USER_COMPANY,
      // USER_ROLE,
      doLogout,
      onClickViewProfile,
      onClickSavedJobs,
      onClickSettings,
      userStore,
    };
  },
});
</script>

<style lang="scss" scoped>
.list {
  &-width {
    min-width: 200px;
    max-width: 350px;
  }
}
#btn-avatar {
  border-radius: 100% !important;
  padding: 0 !important;
}

#view-profile,
#saved-jobs,
#settings,
#signout {
  width: 100% !important;
  background: #f5f5f5 !important;

  &:hover {
    color: #ffffff !important;
    background: $dark-blue !important;
  }
}

span.block {
  width: 60px !important;
}
</style>
